<?php

require_once 'phpunit.php';
include_once '../pctPageProcessor.php';

class pctTestCases extends TestCase
{
	var $processor;
	var $page;
	
	function pctTestCases($name)
	{
		$this->TestCase($name);
	}

	function setUp()
	{
		$this->page = new pctPage;
		$this->page->Template = "<pct:Hello show=\"hi there\">Hello</pct:Hello><p>foobar</p><pct:World>World</pct:World>";
		$this->page->parse();
	}

	function testSetFilenames()
	{
		$this->processor = new pctPageProcessor('test');
		$this->assertEquals( 'test.tpl', $this->processor->TemplateFilename);
		$this->assertEquals( 'test.php', $this->processor->CodebehindFilename);
	}
	function testTagName()
	{
		$this->assertEquals('Hello', $this->page->Tags[0]->Name );
		$this->assertEquals('World', $this->page->Tags[2]->Name );
	}
	function testTagContent()
	{
		$this->assertEquals('<p>foobar</p>', $this->page->Tags[1]->Content );

	}
	function testTagAttribute()
	{
		$this->assertEquals('hi there', $this->page->Tags[0]->Attributes[0]->Value );
	}		
		
}

$suite = new TestSuite;
$suite->addTest( new TestSuite('pctTestCases') );

?>
