<?php
require "phpunit.php";

class TestFixture extends TestCase {
  function TestFixture($name) {
    $this->TestCase($name);
  }

  function setUp() {
    /* put any common setup here */
    $this->intVal = 1;
    $this->strVal = 'foo';
  }

  function testFail1() {
    $this->assert($this->intVal == 0, "1 == 0");
  }

  function testFail2() {
    $this->assert($this->strVal == 'bar');
  }

  function testPass1() {
    $this->assert($this->intVal == 1);
  }
}

$suite = new TestSuite;
$suite->addTest(new TestFixture("testFail1"));
$suite->addTest(new TestFixture("testFail2"));
$suite->addTest(new TestFixture("testPass1"));


class Fixture2 extends TestCase {
  function Fixture2($name) {
    $this->TestCase($name);
  }
  function setUp() {
    $this->str1 = 'foo';
    $this->str2 = 'bar';
  }
  function runTest() {
    $this->testStrNotEqual();
    $this->testStrAppend();
  }
  function testStrNotEqual() {
    $this->assert($this->str1 == $this->str2, 'str equal');
  }
  function testStrAppend() {
    $this->assertEquals($this->str1 . 'bar', 'foobars', 'str append');
  }
}

$suite->addTest(new Fixture2("Fail3"));


class TestPass2 extends TestFixture {
  function TestPass2($name) {  $this->TestFixture($name); }
  function runTest() {
    $this->assertEquals($this->strVal . 'x', $this->strVal . 'x');
    $this->assertEquals($this->strVal . 'x', $this->strVal . 'y');
    $this->assertEquals(1, 0);
    $this->assertEquals(1, "1", 'equals int and str');
  }
}
$suite->addTest(new TestPass2("Fail4"));

class MoreTesterTests extends TestCase {
  function MoreTesterTests($name) {  $this->TestCase($name); }

  function testRegexpPass() {
    $this->assertRegexp('/fo+ba[^a-m]/', 'foobar');
  }

  function testRegexpFail() {
    $this->assertRegexp('/fo+ba[^m-z]/', 'foobar');
  }

  function testRegexpFailWithMessage() {
    $this->assertRegexp('/fo+ba[^m-z]/', 'foobar', "This is the message");   
  }
}
$suite->addTest(new TestSuite("MoreTesterTests"));

class ManyFailingTests extends TestCase {
  function ManyFailingTests($name) {  $this->TestCase($name); }

  function testPass1() { $this->assertEquals(0, 0); }
  function testPass2() { $this->assertEquals(0, 0); }
  function testFail1() { $this->assertEquals(1, 0); }
  function testFail2() { $this->assertEquals(1, 0); }
  function testFail3() { $this->assertEquals(1, 0); }
  function testFail4() { $this->assertEquals(1, 0); }
  function testFail5() { $this->assertEquals(1, 0); }
  function testFail6() { $this->assertEquals(1, 0); }
  function testPass3() { $this->assertEquals(0, 0); }
  function testFail7() { $this->assertEquals(1, 0); }
  function testPass4() { $this->assertEquals(0, 0); }
  function testFail8() { $this->assertEquals(1, 0); }
  function testPass5() { $this->assertEquals(0, 0); }
  function testPass6() { $this->assertEquals(0, 0); }
  function testFail9() { $this->assertEquals(1, 0); }
  function testPass7() { $this->assertEquals(0, 0); }
  function testPass8() { $this->assertEquals(0, 0); }
}

$suite->addTest(new TestSuite("ManyFailingTests"));

$title = 'PhpUnit test run';
?>
<html>
<head><title><?php echo $title; ?></title></head>
<body>
<h1><?php echo $title; ?></h1>
Unlike typical test run, <strong>expect most test cases to fail</strong>.
Exactly those with <code>pass</code> in their name should succeed.
<p>
<?php
if (isset($only))
     $suite = new TestSuite($only);

$testRunner = new TestRunner;
$testRunner->run($suite);
?>
</body>
</html>